<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="月嫂主键" prop="yuesaoId">
        <el-input v-model="formData.yuesaoId" placeholder="请输入月嫂主键" />
      </el-form-item>
      <el-form-item label="月嫂头像地址" prop="avatar">
        <el-input v-model="formData.avatar" placeholder="请输入月嫂头像地址" />
      </el-form-item>
      <el-form-item label="微信号" prop="wechat">
        <el-input v-model="formData.wechat" placeholder="请输入微信号" />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input v-model="formData.mobile" placeholder="请输入手机号" />
      </el-form-item>
      <el-form-item label="学历" prop="schoolDegree">
        <el-input v-model="formData.schoolDegree" placeholder="请输入学历" />
      </el-form-item>
      <el-form-item label="工作历史" prop="workHistory">
        <el-input v-model="formData.workHistory" placeholder="请输入工作历史" />
      </el-form-item>
      <el-form-item label="工作技能" prop="workSkill">
        <el-input v-model="formData.workSkill" placeholder="请输入工作技能" />
      </el-form-item>
      <el-form-item label="期望薪资" prop="expectedSalary">
        <el-input v-model="formData.expectedSalary" placeholder="请输入期望薪资" />
      </el-form-item>
      <el-form-item label="年龄" prop="age">
        <el-input v-model="formData.age" placeholder="请输入年龄" />
      </el-form-item>
      <el-form-item label="籍贯" prop="origin">
        <el-input v-model="formData.origin" placeholder="请输入籍贯" />
      </el-form-item>
      <el-form-item label="子女数" prop="hasChildren">
        <el-input v-model="formData.hasChildren" placeholder="请输入子女数" />
      </el-form-item>
      <el-form-item label="从业时长年" prop="workYear">
        <el-input v-model="formData.workYear" placeholder="请输入从业时长年" />
      </el-form-item>
      <el-form-item label="民族" prop="nation">
        <el-input v-model="formData.nation" placeholder="请输入民族" />
      </el-form-item>
      <el-form-item label="自我介绍" prop="selfIntro">
        <el-input v-model="formData.selfIntro" placeholder="请输入自我介绍" />
      </el-form-item>
      <el-form-item label="个人标签" prop="selfRemarks">
        <el-input v-model="formData.selfRemarks" placeholder="请输入个人标签" />
      </el-form-item>
      <el-form-item label="是否有保险 1=是 0=否" prop="isBaoxian">
        <el-input v-model="formData.isBaoxian" placeholder="请输入是否有保险 1=是 0=否" />
      </el-form-item>
      <el-form-item label="是否体检 1=是 0=否" prop="isTijian">
        <el-input v-model="formData.isTijian" placeholder="请输入是否体检 1=是 0=否" />
      </el-form-item>
      <el-form-item label="保险证明路径" prop="baoxianUrl">
        <el-input v-model="formData.baoxianUrl" placeholder="请输入保险证明路径" />
      </el-form-item>
      <el-form-item label="保险更新时间" prop="baoxianTime">
        <el-date-picker
          v-model="formData.baoxianTime"
          type="date"
          value-format="x"
          placeholder="选择保险更新时间"
        />
      </el-form-item>
      <el-form-item label="体检证明路径" prop="tijianUrl">
        <el-input v-model="formData.tijianUrl" placeholder="请输入体检证明路径" />
      </el-form-item>
      <el-form-item label="体检更新时间" prop="tijianTime">
        <el-date-picker
          v-model="formData.tijianTime"
          type="date"
          value-format="x"
          placeholder="选择体检更新时间"
        />
      </el-form-item>
      <el-form-item label="身份证号" prop="identityNumber">
        <el-input v-model="formData.identityNumber" placeholder="请输入身份证号" />
      </el-form-item>
      <el-form-item label="是否背调" prop="isBeidiao">
        <el-input v-model="formData.isBeidiao" placeholder="请输入是否背调" />
      </el-form-item>
      <el-form-item label="背调时间" prop="beidiaoTime">
        <el-date-picker
          v-model="formData.beidiaoTime"
          type="date"
          value-format="x"
          placeholder="选择背调时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ResumeApi from '@/api/yuesao/resume'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  yuesaoId: undefined,
  avatar: undefined,
  wechat: undefined,
  mobile: undefined,
  schoolDegree: undefined,
  workHistory: undefined,
  workSkill: undefined,
  expectedSalary: undefined,
  age: undefined,
  origin: undefined,
  hasChildren: undefined,
  workYear: undefined,
  nation: undefined,
  selfIntro: undefined,
  selfRemarks: undefined,
  isBaoxian: undefined,
  isTijian: undefined,
  baoxianUrl: undefined,
  baoxianTime: undefined,
  tijianUrl: undefined,
  tijianTime: undefined,
  identityNumber: undefined,
  isBeidiao: undefined,
  beidiaoTime: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ResumeApi.getResume(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ResumeApi.ResumeVO
    if (formType.value === 'create') {
      await ResumeApi.createResume(data)
      message.success(t('common.createSuccess'))
    } else {
      await ResumeApi.updateResume(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    yuesaoId: undefined,
    avatar: undefined,
    wechat: undefined,
    mobile: undefined,
    schoolDegree: undefined,
    workHistory: undefined,
    workSkill: undefined,
    expectedSalary: undefined,
    age: undefined,
    origin: undefined,
    hasChildren: undefined,
    workYear: undefined,
    nation: undefined,
    selfIntro: undefined,
    selfRemarks: undefined,
    isBaoxian: undefined,
    isTijian: undefined,
    baoxianUrl: undefined,
    baoxianTime: undefined,
    tijianUrl: undefined,
    tijianTime: undefined,
    identityNumber: undefined,
    isBeidiao: undefined,
    beidiaoTime: undefined
  }
  formRef.value?.resetFields()
}
</script>
